//-------------------- -------------------------------------
char uart_rd;
unsigned short BUFfrom[64];

char txt[16];
char txt1[] = "PROGRAMMED OK";
volatile unsigned short ByteRS;                                                 //     com-

unsigned char  *chip[]={"SCX-4200", "SCX-4520", "SCX-4720", "SCX-5330", "SCX-6320", "ML-2150 ",
"ML-2250 ", "ML-2550 ", "ML-2850 ", "ML-3470 ", "ML-3560 ", "PE-120  ", "PE-220  ", "WC-3119 ",
"WC-4118 ", "Pha-3150", "Pha-3420", "Pha-3450", "Pha-3500", "M-20i   "};

/*
volatile char *t[0] =  "SCX-4200";
volatile char *t[1] =  "SCX-4520";
volatile char *t[2] =  "SCX-4720";
volatile char *t[3] =  "SCX-5330";
volatile char *t[4] =  "SCX-6320";

volatile char t6[] =  "ML-2150";
volatile char t7[] =  "ML-2250";
volatile char t8[] =  "ML-2550";
volatile char t9[] =  "ML-2850";
volatile char t10[] = "ML-3470";
volatile char t11[] = "ML-3560";
volatile char t12[] = "PE-120";
volatile char t13[] = "PE-220";
volatile char t14[] = "WC-3119";
volatile char t15[] = "WC-4118";
volatile char t16[] = "Phaser-3150";
volatile char t17[] = "Phaser-3420";
volatile char t18[] = "Phaser-3450";
volatile char t19[] = "Phaser-3500";
volatile char t20[] = "M-20i";    */

// LCD module connections
  sbit LCD_RS at RB2_bit;
  sbit LCD_EN at RB3_bit;
  sbit LCD_D4 at RB4_bit;
  sbit LCD_D5 at RB5_bit;
  sbit LCD_D6 at RB6_bit;
  sbit LCD_D7 at RB7_bit;

  sbit LCD_RS_Direction at TRISB2_bit;
  sbit LCD_EN_Direction at TRISB3_bit;
  sbit LCD_D4_Direction at TRISB4_bit;
  sbit LCD_D5_Direction at TRISB5_bit;
  sbit LCD_D6_Direction at TRISB6_bit;
  sbit LCD_D7_Direction at TRISB7_bit;
// End LCD module connections

//-----------------------------------------------------------------------

 void ReadEEPROM(char adr_h, char adr_l)                                        //   24512 0-256 
 
{
  unsigned short k;

  for (k=0; k<64; k++)
  {
  I2C1_Start();                                                                 // issue I2C start signal
  I2C1_Wr(0xA2);                                                                // send byte via I2C  (device address + W)
  I2C1_Wr(adr_h);                                                               //   
  I2C1_Wr(k + adr_l);                                                           // send byte (data address)
  I2C1_Repeated_Start();                                                        // issue I2C signal repeated start
  I2C1_Wr(0xA3);                                                                // send byte (device address + R)
  BUFfrom[k] = I2C1_Rd(0u);                                                     //
  I2C1_Stop();                                                                  // issue I2C stop signal

  }
  ByteRS=0;                                                                     // 
}

 void WriteEEPROM_0_bank(char adr)                                              //   2404  0-256 
 {
  unsigned short k;
  for (k=0; k<64; k++)
  {
  I2C1_Start();                                                                 // issue I2C start signal
  I2C1_Wr(0xA0);                                                                // send byte via I2C  (device address + 0_ + W)
  I2C1_Wr(k + adr);                                                                   // send byte (address of EEPROM location)
  I2C1_Wr(BUFfrom[k]);                                                          // send data (data to be written)
  I2C1_Stop();                                                                  // issue I2C stop signal
  Delay_ms(1);
  }                                                                             // issue I2C stop signal
  ByteRS=0;
 }
 
 void WriteEEPROM_1_bank(char adr)                                                   //   2404  257-512 
 {
  unsigned short k;
  for (k=0; k<64; k++)
  {
  I2C1_Start();                                                                 // issue I2C start signal
  I2C1_Wr(0xA2);                                                                // send byte via I2C  (device address + 1_ + W)
  I2C1_Wr(k + adr);                                                                   // send byte (address of EEPROM location)
  I2C1_Wr(BUFfrom[k]);                                                          // send data (data to be written)
  I2C1_Stop();                                                                  // issue I2C stop signal
  Delay_ms(1);
  }                                                                             // issue I2C stop signal
  ByteRS=0;
 }
 
 void CopyEEPROM(char adr_h, char adr_l, char txt[16])                                                          //    24512  2404 512 
  {

  /* ReadEEPROM(adr_h, adr_l);                    //0-64              24c04
   WriteEEPROM_0_bank(0x00);

   ReadEEPROM(adr_h, adr_l + 64);               //65-128
   WriteEEPROM_0_bank(64);

   ReadEEPROM(adr_h, adr_l + 128);              //129-192
   WriteEEPROM_0_bank(128);
   
   ReadEEPROM(adr_h, adr_l + 192);             //193-256
   WriteEEPROM_0_bank(192);

   ReadEEPROM(adr_h + 1, adr_l);               //                   24c04
   WriteEEPROM_1_bank(0x00);

   ReadEEPROM(adr_h + 1, adr_l + 64);
   WriteEEPROM_1_bank(64);

   ReadEEPROM(adr_h + 1, adr_l + 128);
   WriteEEPROM_1_bank(128);

   ReadEEPROM(adr_h + 1, adr_l + 192);
   WriteEEPROM_1_bank(192);     */
   ByteRS=0;
   Lcd_Init();
   Lcd_Cmd(_LCD_CLEAR);
   Lcd_Cmd(_LCD_CURSOR_OFF);
   Lcd_Out(1,4,txt);
   Lcd_Out(2,2,txt1);

   }
   
  void FormatEEPROM(void)                                                       //   2404
  {
   unsigned int i;
   for (i=0; i<=255; i++)
  {
  I2C1_Start();                                                                 // issue I2C start signal
  I2C1_Wr(0xA0);                                                                // send byte via I2C  (device address + 0_bank + W)
  I2C1_Wr(i);                                                                   // send byte (address of EEPROM location)
  I2C1_Wr(0xFF);                                                                //    
  I2C1_Stop();                                                                  // issue I2C stop signal
  Delay_ms(1);
  }
  for (i=0; i<=255; i++)
  {
  I2C1_Start();                                                                 // issue I2C start signal
  I2C1_Wr(0xA2);                                                                // send byte via I2C  (device address + 1_bank + W)
  I2C1_Wr(i);                                                                   // send byte (address of EEPROM location)
  I2C1_Wr(0xFF);                                                                //     000
  I2C1_Stop();                                                                  // issue I2C stop signal
  Delay_ms(1);
  }                                                                             // issue I2C stop signal
  ByteRS=0;
  UART1_Write_Text("FORMAT EEPROM OK");
  Lcd_Cmd(_LCD_CLEAR);                                                          // Clear display
  Lcd_Out(1,1,"FORMAT EEPROM OK");                                              // Write text in first row
  }
  
//--------------------------------------------------------------------

void interrupt() {

  if (PIR1.F5) {
     ByteRS=RCREG;
     PIR1.F5 = 0;
     }
}//~

//--------------------------- ------------------------------------
void main()
{
  bit oldstate, oldstate0, oldstate1, oldstate2, oldstate3, oldstate4, oldstate5;
  unsigned short N = 1;                                                             //   
  TRISB=0b00000011;                                                             //0  1    ,   
  OPTION_REG.F7 = 0;                                                            //    
  TRISC=0b11111111;                                                             //
  TRISA=0b11111111;                                                             //
  PORTA=0b00111111;                                                             //
  ADCON1 = 0x06;                                                                // PORTA 
  INTCON.F6 = 1;                                                                //    
  OPTION_REG.F6 = 1;                                                            //      INT
  INTCON.F4 = 0;                                                                //     INT __________________
  PIE1.F5 = 1;                                                                  //    USART
  INTCON.F7 = 1;                                                                //  
  UART1_Init(9600);                                                             // UART module  9600 bps
  Delay_ms(100);                                                                //  UART module 


  UART1_Write_Text("Start\n");                                                  //  Usart
  ADCON1 = 0x06;                                                                // PORTA 
  I2C1_Init(100000);                                                            // initialize I2C communication

  Lcd_Init();                                                                   // Initialize LCD
  Lcd_Cmd(_LCD_CLEAR);                                                          // Clear display
  Lcd_Cmd(_LCD_CURSOR_OFF);                                                     // Cursor off
  Lcd_Out(1,1,"RUSSO_TURISTO");                                                 // Write text in first row
  Lcd_Out(2,4,"COPY EEPROM");                                                   // Write text in second row
  Delay_ms(2000);

  while (1)
   {
    Lcd_Cmd(_LCD_CLEAR);
    Lcd_Cmd(_LCD_CURSOR_OFF);
    Lcd_Out(1,8,"3");
    Lcd_Out(2,1,&chip[3]);
    UART1_Write_Text(&chip[3]);
    

    while (PORTA & 0b00001111)//do {
    if (Button(&PORTA, 1, 10, 0)) oldstate = 1;
    if (oldstate && Button(&PORTA, 0, 10, 1))
    {
    N=N+1;
    Lcd_Cmd(_LCD_CLEAR);
    Lcd_Cmd(_LCD_CURSOR_OFF);
    Lcd_Out(1,1,&chip[1]);
    Lcd_Out(2,4,"COPY EEPROM");
    oldstate = 0;
    }
       // }

     /*switch (ByteRS)
     {
        case '1': CopyEEPROM(0x00,0x00,"SCX-4200"); break;                                 //
        case '2': CopyEEPROM(0x02,0x00,"SCX-4520"); break;                                 //
        case '3': CopyEEPROM(0x04,0x00,"SCX-4720"); break;                                 //
        case '4': CopyEEPROM(0x06,0x00,"SCX-5330"); break;                                 //
        case '5': CopyEEPROM(0x08,0x00,"SCX-6320"); break;                                 //
        case '6': CopyEEPROM(0x0A,0x00,"ML-2150"); break;                                 //
        case '7': CopyEEPROM(0x0C,0x00,"ML-2250"); break;                                 //
        case '8': CopyEEPROM(0x0E,0x00,"ML-2550"); break;                                 //
        case '9': CopyEEPROM(0x10,0x00,"ML-2850"); break;                                 //
        case 'A': CopyEEPROM(0x12,0x00,"ML-3470"); break;                                 //
        case 'B': CopyEEPROM(0x14,0x00,"ML-3560"); break;                                 //
        
        case 'F': FormatEEPROM(); break;                                        // 
        default : break;                                                        //  
     }  */
   }
   }                                                                           //   
                                                                                //  
