#line 1 "I:/I2C/I2C.c"

char uart_rd;
unsigned short BUFfrom[64];

char txt[16];
char txt1[] = "PROGRAMMED OK";
volatile unsigned short ByteRS;

unsigned char *chip[]={"SCX-4200", "SCX-4520", "SCX-4720", "SCX-5330", "SCX-6320", "ML-2150 ",
"ML-2250 ", "ML-2550 ", "ML-2850 ", "ML-3470 ", "ML-3560 ", "PE-120  ", "PE-220  ", "WC-3119 ",
"WC-4118 ", "Pha-3150", "Pha-3420", "Pha-3450", "Pha-3500", "M-20i   "};
#line 37 "I:/I2C/I2C.c"
 sbit LCD_RS at RB2_bit;
 sbit LCD_EN at RB3_bit;
 sbit LCD_D4 at RB4_bit;
 sbit LCD_D5 at RB5_bit;
 sbit LCD_D6 at RB6_bit;
 sbit LCD_D7 at RB7_bit;

 sbit LCD_RS_Direction at TRISB2_bit;
 sbit LCD_EN_Direction at TRISB3_bit;
 sbit LCD_D4_Direction at TRISB4_bit;
 sbit LCD_D5_Direction at TRISB5_bit;
 sbit LCD_D6_Direction at TRISB6_bit;
 sbit LCD_D7_Direction at TRISB7_bit;




 void ReadEEPROM(char adr_h, char adr_l)

{
 unsigned short k;

 for (k=0; k<64; k++)
 {
 I2C1_Start();
 I2C1_Wr(0xA2);
 I2C1_Wr(adr_h);
 I2C1_Wr(k + adr_l);
 I2C1_Repeated_Start();
 I2C1_Wr(0xA3);
 BUFfrom[k] = I2C1_Rd(0u);
 I2C1_Stop();

 }
 ByteRS=0;
}

 void WriteEEPROM_0_bank(char adr)
 {
 unsigned short k;
 for (k=0; k<64; k++)
 {
 I2C1_Start();
 I2C1_Wr(0xA0);
 I2C1_Wr(k + adr);
 I2C1_Wr(BUFfrom[k]);
 I2C1_Stop();
 Delay_ms(1);
 }
 ByteRS=0;
 }

 void WriteEEPROM_1_bank(char adr)
 {
 unsigned short k;
 for (k=0; k<64; k++)
 {
 I2C1_Start();
 I2C1_Wr(0xA2);
 I2C1_Wr(k + adr);
 I2C1_Wr(BUFfrom[k]);
 I2C1_Stop();
 Delay_ms(1);
 }
 ByteRS=0;
 }

 void CopyEEPROM(char adr_h, char adr_l, char txt[16])
 {
#line 130 "I:/I2C/I2C.c"
 ByteRS=0;
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1,4,txt);
 Lcd_Out(2,2,txt1);

 }

 void FormatEEPROM(void)
 {
 unsigned int i;
 for (i=0; i<=255; i++)
 {
 I2C1_Start();
 I2C1_Wr(0xA0);
 I2C1_Wr(i);
 I2C1_Wr(0xFF);
 I2C1_Stop();
 Delay_ms(1);
 }
 for (i=0; i<=255; i++)
 {
 I2C1_Start();
 I2C1_Wr(0xA2);
 I2C1_Wr(i);
 I2C1_Wr(0xFF);
 I2C1_Stop();
 Delay_ms(1);
 }
 ByteRS=0;
 UART1_Write_Text("FORMAT EEPROM OK");
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1,1,"FORMAT EEPROM OK");
 }



void interrupt() {

 if (PIR1.F5) {
 ByteRS=RCREG;
 PIR1.F5 = 0;
 }
}


void main()
{
 bit oldstate, oldstate0, oldstate1, oldstate2, oldstate3, oldstate4, oldstate5;
 unsigned short N = 1;
 TRISB=0b00000011;
 OPTION_REG.F7 = 0;
 TRISC=0b11111111;
 TRISA=0b11111111;
 PORTA=0b00111111;
 ADCON1 = 0x06;
 INTCON.F6 = 1;
 OPTION_REG.F6 = 1;
 INTCON.F4 = 0;
 PIE1.F5 = 1;
 INTCON.F7 = 1;
 UART1_Init(9600);
 Delay_ms(100);


 UART1_Write_Text("Start\n");
 ADCON1 = 0x06;
 I2C1_Init(100000);

 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1,1,"RUSSO_TURISTO");
 Lcd_Out(2,4,"COPY EEPROM");
 Delay_ms(2000);

 while (1)
 {
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1,8,"3");
 Lcd_Out(2,1,&chip[3]);
 UART1_Write_Text(&chip[3]);


 while (PORTA & 0b00001111)
 if (Button(&PORTA, 1, 10, 0)) oldstate = 1;
 if (oldstate && Button(&PORTA, 0, 10, 1))
 {
 N=N+1;
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1,1,&chip[1]);
 Lcd_Out(2,4,"COPY EEPROM");
 oldstate = 0;
 }
#line 246 "I:/I2C/I2C.c"
 }
 }
